#!/bin/bash
if [ $# -ne 4 ] ; then 
    echo "Usage `basename $0` [params folder] [params file (without _ep ext)] [start epoch] [stop epoch]"
    exit 1;
fi 

. path.sh
params_folder=$1
nn_params_file=$2
echo Processing dataset $nn_params_file | tee -a /dev/stderr
pred_file_pref=$1/$nn_params_file
start_ep=$3
end_ep=$4

for epoch in `seq $start_ep $end_ep` ; do
   pred_file=${pred_file_pref}"_ep_"$epoch
   echo local/decode_nn_predictions.sh $pred_file | tee -a /dev/stderr
   local/decode_nn_predictions.sh $pred_file 
done
