beam=500
symtab="data/lang/words.txt"
model="exp/mono/final.mdl"
graphdir="exp/mono/graph"
db_name="dev"
pred_file=$1".dev.scores"

#echo "Decoding parameters: " 2 > /dev/stderr
#echo "	db_name = " $db_name  2> /dev/stderr
#echo "	prediction file = "$pred_file  2> /dev/stderr


outdir="exp/mono/scores/"$db_name
trans_file=$outdir/$db_name.tra
ali_file=$outdir/$db_name.ali

ref_file="data/"$db_name/text

TFILE="/tmp/$(basename $0).$$.tmp"
TFILE_WER="/tmp/$(basename $0).$$.wer.tmp"
TSCORE_FILE="/tmp/$(basename $0).$$.score.tmp"

mkdir -p $outdir
rm -f $TSCORE_FILE
mapping="en:n,ao:aa,ax-h:ah,ax:ah,ix:ih,el:l,zh:sh,ux:uw,axr:er,em:m,nx:n,eng:ng,hv:hh,pcl:pau,tcl:pau,kcl:pau,q:pau,bcl:pau,dcl:pau,gcl:pau,epi:pau"
#mapping="sil:pau,esil:pau,en:n,ao:aa,ax-h:ah,ax:ah,ix:ih,el:l,zh:sh,ux:uw,axr:er,em:m,nx:n,eng:ng,hv:hh,pcl:pau,tcl:pau,kcl:pau,q:pau,bcl:pau,dcl:pau,gcl:pau,epi:pau"
for acousticscale in 1.1 1. .9 .8 .7 .6; do
   cat $pred_file | decode-faster-mapped --beam=$beam \
                      --acoustic-scale=$acousticscale \
                      --word-symbol-table=$symtab $model $graphdir/HCLG.fst \
                      ark,t:- ark,t:$trans_file ark,t:$ali_file 2>> $outdir.log

   scripts/collapse_phones.pl --ignore-first-field $symtab \
                                   $mapping < $trans_file > $TFILE
 
   score=$(scripts/sym2int.pl --ignore-first-field $symtab $ref_file | \
        scripts/collapse_phones.pl --ignore-first-field $symtab $mapping |\
        compute-wer --mode=present ark:-  ark,p:$TFILE 2>/dev/null | grep "%WER" | awk '{print $2; }')
   echo "Dev set acoustic scale =" $acousticscale " err = " $score >>  /dev/stderr
   echo $acousticscale " " $score >> $TSCORE_FILE
done
rm $TFILE

acousticscale=$(cat $TSCORE_FILE  | perl min_score.pl)
min_err=$(cat $TSCORE_FILE  | perl min_score.pl blah)
#rm $TSCORE_FILE 

echo "Dev set error = $min_err Acoustic scale =  $acousticscale " | tee -a /dev/stderr


db_name="test"
pred_file=$1".core.scores"
outdir="exp/mono/scores/"$db_name
trans_file=$outdir/$db_name.tra
ali_file=$outdir/$db_name.ali

ref_file="data/"$db_name/text

mkdir -p $outdir
cat $pred_file | decode-faster-mapped --beam=$beam \
                   --acoustic-scale=$acousticscale \
                   --word-symbol-table=$symtab $model $graphdir/HCLG.fst \
                   ark,t:- ark,t:$trans_file ark,t:$ali_file 2>> $outdir.log

echo -n "Test set error = " | tee -a /dev/stderr
scripts/collapse_phones.pl --ignore-first-field $symtab \
                                        $mapping < $trans_file > $TFILE
scripts/sym2int.pl --ignore-first-field $symtab $ref_file | \
     scripts/collapse_phones.pl --ignore-first-field $symtab $mapping |\
     compute-wer --mode=present ark:-  ark,p:$TFILE 2>/dev/null > $TFILE_WER

head -1 $TFILE_WER | awk '{split($0, a, " ") ; for (i = 2 ; i <= length(a) ; i++) { printf  a[i]  " " ; }; print ""; }' | tee -a /dev/stderr
