#!/usr/bin/perl
# Copyright 2012 Navdeep Jaitly

# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#  http://www.apache.org/licenses/LICENSE-2.0
#
# THIS CODE IS PROVIDED *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
# WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
# MERCHANTABLITY OR NON-INFRINGEMENT.
# See the Apache 2 License for the specific language governing permissions and
# limitations under the License.

use Scalar::Util qw(looks_like_number);

if(@ARGV < 1) {
    die "Usage: replace_bow.pl [word:type(b/p):value] [word:type(b/p):value] ...";
}
my %word_type ; 
my %word_value ; 
for my $val (@ARGV) {
   my @parts = split(":", $val);
   $word_type{$parts[0]} = $parts[1];
   if (@parts > 2) {
      $word_value{$parts[0]} = $parts[2] ; 
   } else {
      $word_value{$parts[0]} = "" ; 
      print "p: $parts[0]\n";
   }
}

my $start = 0;
while (<STDIN>) {
   chomp ($_); 
   my $line = $_;
   if ($line eq "\\1-grams:") {
      $start = 1;
   } elsif ($line eq "\\2-grams:") {
      $start = 0;
   }
   if ($start == 1) {
      my @parts = split(" ", $line);
      if (@parts == 1){ 
         print "$_\n" ;
      } else {
        my $wrd = $parts[1];
        my $prob =  "" ;
        if (@parts == 3) {
          $prob = $parts[2];
        }
        # check if word bow / prob needs changing.
        if (exists($word_type{$wrd})) {
           if ($word_type{$wrd} eq "b") {
             print "$parts[0] $wrd $word_value{$wrd}\n";
           } else {
             print "$word_value{$wrd} $wrd $prob\n";
           }
        } else {
         print "$_\n" ;
        }
      }
   } else {
      print "$_\n";
   }
}
